import { ModuleWithProviders } from '@angular/core';
import * as i0 from "@angular/core";
import * as i1 from "./directive/permissions.directive";
import * as i2 from "./testing/permissions-allow.directive.stub";
import * as i3 from "./testing/permissions-restrict.directive.stub";
export * from './store/roles.store';
export * from './store/permissions.store';
export * from './store/configuration.store';
export * from './directive/permissions.directive';
export * from './service/permissions.service';
export * from './service/roles.service';
export * from './service/configuration.service';
export * from './router/permissions-guard.service';
export * from './model/permissions-router-data.model';
export * from './model/role.model';
export * from './testing/permissions-allow.directive.stub';
export * from './testing/permissions-restrict.directive.stub';
export * from './enums/predefined-strategies.enum';
export interface NgxPermissionsModuleConfig {
    rolesIsolate?: boolean;
    permissionsIsolate?: boolean;
    configurationIsolate?: boolean;
}
export declare class NgxPermissionsModule {
    static forRoot(config?: NgxPermissionsModuleConfig): ModuleWithProviders<NgxPermissionsModule>;
    static forChild(config?: NgxPermissionsModuleConfig): ModuleWithProviders<NgxPermissionsModule>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxPermissionsModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgxPermissionsModule, [typeof i1.NgxPermissionsDirective], never, [typeof i1.NgxPermissionsDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgxPermissionsModule>;
}
export declare class NgxPermissionsAllowStubModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxPermissionsAllowStubModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgxPermissionsAllowStubModule, never, [typeof i2.NgxPermissionsAllowStubDirective], [typeof i2.NgxPermissionsAllowStubDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgxPermissionsAllowStubModule>;
}
export declare class NgxPermissionsRestrictStubModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxPermissionsRestrictStubModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgxPermissionsRestrictStubModule, never, [typeof i3.NgxPermissionsRestrictStubDirective], [typeof i3.NgxPermissionsRestrictStubDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgxPermissionsRestrictStubModule>;
}
